;;; Functions to be changed on transport

(in-package "LISP")
(mapcar #'fmakunbound '(machine-type machine-version machine-instance
                        short-site-name long-site-name edit-file))

(defun machine-type () "Atari ST")
(defun machine-version () "1040 ST/F")
(defun machine-instance () "Bruno Haible's home computer")

(defun short-site-name () "Karlsruhe")
(defun long-site-name () "Ritterstrae 42, D - W7500 Karlsruhe")

;; (edit-file file) edits a file.
(defun edit-file (file)
  (prog1
    (execute "TEMPUS.PRG" ; the name of the editor
             (namestring file t) ; file as a string in GEMDOS format
             (round (* 0.99 (gc))) ; editor gets 99% of the free memory
    )
    (write-string (coerce '(#\Escape #\E) 'string) ; clear screen
                  *terminal-io*
) ) )

;; The temporary file LISP creates for editing:
(defparameter tempfile "LISPTEMP.LSP")

;; The list of directories where programs are searched by LOAD etc.:
(defparameter *load-paths* '(#"A:" #"A:\\" #"A:\\...\\"))

